'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var cn = require('classnames');
var hooks = require('@alfalab/hooks');
var mergeRefs = require('react-merge-refs');
var CheckmarkCompactMIcon = require('@alfalab/icons-glyph/CheckmarkCompactMIcon');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var cn__default = /*#__PURE__*/_interopDefaultLegacy(cn);
var mergeRefs__default = /*#__PURE__*/_interopDefaultLegacy(mergeRefs);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
var __assign = function () {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s)
                if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
function __rest(s, e) {
    var t = {};
    for (var p in s)
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

var styles = {"component":"checkbox__component_e67wi","start":"checkbox__start_e67wi","center":"checkbox__center_e67wi","addons":"checkbox__addons_e67wi","block":"checkbox__block_e67wi","box":"checkbox__box_e67wi","checkedIcon":"checkbox__checkedIcon_e67wi","s":"checkbox__s_e67wi","disabled":"checkbox__disabled_e67wi","inactive":"checkbox__inactive_e67wi","checked":"checkbox__checked_e67wi","indeterminate":"checkbox__indeterminate_e67wi","label":"checkbox__label_e67wi","hint":"checkbox__hint_e67wi","focused":"checkbox__focused_e67wi","content":"checkbox__content_e67wi","errorMessage":"checkbox__errorMessage_e67wi","indeterminateLine":"checkbox__indeterminateLine_e67wi"};
require('./index.css')

var Checkbox = React.forwardRef(function (_a, ref) {
    var _b;
    var checked = _a.checked, label = _a.label, hint = _a.hint, _c = _a.size, size = _c === void 0 ? 's' : _c, boxClassName = _a.boxClassName, contentClassName = _a.contentClassName, _d = _a.align, align = _d === void 0 ? 'start' : _d, addons = _a.addons, block = _a.block, onChange = _a.onChange, className = _a.className, name = _a.name, disabled = _a.disabled, inactive = _a.inactive, dataTestId = _a.dataTestId, _e = _a.indeterminate, indeterminate = _e === void 0 ? false : _e, error = _a.error, restProps = __rest(_a, ["checked", "label", "hint", "size", "boxClassName", "contentClassName", "align", "addons", "block", "onChange", "className", "name", "disabled", "inactive", "dataTestId", "indeterminate", "error"]);
    var labelRef = React.useRef(null);
    var focused = hooks.useFocus(labelRef, 'keyboard')[0];
    var handleChange = function (event) {
        if (onChange) {
            onChange(event, { checked: event.target.checked, name: name });
        }
    };
    var errorMessage = typeof error === 'boolean' ? '' : error;
    return (
    // eslint-disable-next-line jsx-a11y/label-has-associated-control
    React__default['default'].createElement("label", { className: cn__default['default'](styles.component, styles[size], styles[align], className, (_b = {},
            _b[styles.disabled] = disabled,
            _b[styles.inactive] = inactive,
            _b[styles.checked] = checked,
            _b[styles.indeterminate] = indeterminate,
            _b[styles.focused] = focused,
            _b[styles.block] = block,
            _b)), ref: mergeRefs__default['default']([labelRef, ref]) },
        React__default['default'].createElement("input", __assign({ type: 'checkbox', onChange: handleChange, disabled: disabled || inactive, checked: checked, "data-test-id": dataTestId }, restProps)),
        React__default['default'].createElement("span", { className: cn__default['default'](styles.box, boxClassName) },
            checked && React__default['default'].createElement(CheckmarkCompactMIcon.CheckmarkCompactMIcon, { className: styles.checkedIcon }),
            indeterminate && !checked && React__default['default'].createElement("span", { className: styles.indeterminateLine })),
        (label || hint || errorMessage) && (React__default['default'].createElement("span", { className: cn__default['default'](styles.content, contentClassName) },
            label && React__default['default'].createElement("span", { className: styles.label }, label),
            hint && !errorMessage && React__default['default'].createElement("span", { className: styles.hint }, hint),
            errorMessage && (React__default['default'].createElement("span", { className: styles.errorMessage, role: 'alert' }, errorMessage)))),
        addons && React__default['default'].createElement("span", { className: styles.addons }, addons)));
});
/**
 * Для отображения в сторибуке
 */
Checkbox.defaultProps = {
    indeterminate: false,
};

exports.Checkbox = Checkbox;
